<?php
class clase_noticias {
	/**
	 * Padre de la clase
	 *
	 * @var juego
	 */
	var $padre;
	/**
	 * clase de bd
	 *
	 * @var clase_bd
	 */
	var $bd;
	/**
	 * Constructor
	 *
	 * @param juego $_padre
	 * @return clase_noticias
	 */
	function clase_noticias(&$_padre){
		$this->padre = &$_padre;
		$this->bd    = $this->padre->bd;
	}
	
	/**
	 * Devuelve una lista de noticias,como un array
	 *
	 * @param str $idioma
	 * @param str $tipo
	 * @param str $where
	 * @param str $order
	 * @param str $limit
	 * @return array
	 */
	function listaNoticias($idioma,$tipo="",$where="",$order="order by f_alta desc",$limit=""){
		if (empty($where)) $where = " where tipo='".$tipo."' and publicada=1 ";
		$r = $this->bd->seleccion("idn,titulo_".$idioma.",HTML_".$idioma." from noticias".$where.$order.$limit);
		if (!$r) return array();
		$noticias = array();
		while ($noticia = $this->bd->obtener_fila($r)) {
			array_push($noticias,$noticia);
		}
		@mysql_free_result($r);
		unset($noticia);
		return $noticias;
	}
	/**
	 * Lee una noticia devolviendo la tupla de la BD
	 *
	 * @param int $idn
	 * @param char(2) $idioma
	 * @return array
	 */
	function leerNoticia($idn,$idioma){
		$r = $this->bd->seleccion("idn,titulo_".$idioma.",HTML_".$idioma." from noticias".
					" where idn=".intval($idn)." and publicada=1 ");
		if (!$r) return array();
		return $this->bd->obtener_fila_unica($r);
	}
	function ultima_noticia(){
		return $this->bd->seleccion_unica("max(idn) from noticias");
	}
	
	function existeNoticia($idn){
		if (empty($idioma)) $idioma = $this->padre->idioma;
		return intval($this->bd->seleccion_unica("idn from noticias where idn=".intval($idn)));
	}
	
	function titulo($idn,$idioma="")
	{
		if (empty($idioma)) $idioma = $this->padre->idioma;
		return $this->bd->seleccion_unica("titulo_".$idioma." from noticias where idn=".intval($idn));
	}
	
}
?>