<?php
/**
 * @package    Download
 * @license    http://opensource.org/licenses/gpl-license.php GNU Public License
 * @author     Alex Sancho <alex@alexsancho.name>
 * @link       http://alexsancho.name/
 * @copyright  Copyright &copy; 2007. Alex Sancho
 * @version    $Version: 1.0.0$
 * @access     public
 */
    class download {
        /**
	 * @var int
	 * @access public
	 */
	var $files = 0;
        /**
	 * @var array
	 * @access public
	 */
	var $fileTypes = array();
        /**
	 * @var array
	 * @access private
	 */
	var $mimeTypes = array();
        /**
	 *  Constructor
	 * 
	 * @param string
	 * @access public
	 */
	function download($path) {
	    $this->path = $path;
	    $this->fileTypes = array('jpeg', 'jpg', 'ico', 'png', 'gif', 'bmp');
	    $this->ini = DIR_PPAL."config/mime-type.ini";
	    $this->mimeTypes = parse_ini_file($this->ini, false);
	}
        /**
	 *  get mime type
	 *
	 * @access private
	 * @return string
	 */
	function getMimetype() {
	    return (!$this->checkMimetype()) ? 'application/force-download' : $this->mimeTypes[$this->fext];
	}
        /**
	 *  check mime type
	 *
	 * @access private
	 * @return bool
	 */
	function checkMimetype() {
	    return isset($this->mimeTypes[$this->fext]) ? true : false;
	} 
        /**
	 *  get file
	 *
	 * @param string
	 * @access public
	 */
	function get($req) {
	    preg_match("/^[\.\-\s#_a-zA-Z\d]+$/", $req, $file);
	    $this->file = $this->path.$file[0];
	    if(!file_exists($this->file)) die("Wrong File Name");
    	    $this->parts = pathinfo($this->file);
	    $this->fname = $this->parts['basename'];
	    $this->fext = strtolower($this->parts['extension']);
	    $this->fsize = filesize($this->file);
	    $this->type = $this->getMimetype();
	    
	    $this->_send();
	}
        /**
	 *  send file
	 *
	 * @access private
	 * @return binary
	 */
	function _send() {
	    if(ini_get('zlib.output_compression')) ini_set('zlib.output_compression', 'Off');

	    header("Pragma: public");
	    header("Expires: 0");
	    header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	    header("Cache-Control: private",false);
    	    header("Content-type: ".$this->type."");
    	    header("Content-Disposition: attachment; filename=\"".$this->fname."\"");
	    header("Content-Transfer-Encoding: Binary");
    	    header("Content-length: ".$this->fsize."");
	    set_time_limit(0);
	    readfile($this->file);
	    exit();
	}
        /**
	 *  get file type
	 *
	 * @param string
	 * @access private
	 * @return string
	 */
	function _type($file) {
	    $dotpos = strrpos($file, ".");
	    return strtolower(substr($file, $dotpos + 1));
	}
        /**
	 *  build select
	 *
	 * @param string
	 * @param string
	 * @param string
	 * @param int
	 * @access public
	 * @return mixed
	 */
	function select($name = 'files', $label = '', $curr = '', $chars = 30) {
	    if ($handle = opendir($this->path)) {
		$select = '<form method="post" action="'.$_SERVER['PHP_SELF'].'">'."\n";
    		$select .= ($label != '') ? '<label for="'.$name.'">'.$label.'</label>'."\n" : '';
	        $select .= '<select name="'.$name.'" id="'.$name.'">'."\n";
		$curr = (isset($_REQUEST[$name])) ? $_REQUEST[$name] : $curr;
		$select .= ($curr == "") ? "  <option value=\"\" selected>...\n" : "<option value=\"\">...\n";
	        while (false !== ($file = readdir($handle))) {
    		    $array[] = $file;
    		}
	        closedir($handle);
    		sort($array);
    		foreach ($array as $val) {
		    $ext = $this->_type($val);
    	    	    if (is_file($this->path.$val) && array_search($ext, $this->fileTypes) !== false) {
        	        $select .= '    <option value="'.$val.'">';
            		$select .= (strlen($val) > $chars) ? substr($val, 0, $chars).'..'."</option>\n" : $val."</option>\n";
            		$this->files++;
        	    }
    		}
    		$select .= '</select>'."\n";
		$select .= '<input type="submit" name="download" value="Download" />'."\n";
		$select .= '</form>'."\n";
	    }
	    return ($this->files == 0) ? "No files!" : $select;
	} 
    }
?>